/***************************************************************************
 *   Copyright (C) 2004 by Cyril Bosselut                                  *
 *   bosselut@b1project.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KTAGMAINWIN_H
#define KTAGMAINWIN_H
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <qlabel.h>
#include <qdir.h>
#include <qdragobject.h>
#include <qwidgetstack.h>
#include <qlistbox.h>

#include <ktabwidget.h>
#include <kiconloader.h>
#include <kuniqueapplication.h>
#include <kmainwindow.h>
#include <kmessagebox.h>
#include <kstdaction.h>
#include <kaction.h>
#include <klocale.h>
#include <kfiledialog.h>
#include <kprogress.h>

#include "dcopiface.h"
#include "ktag.h"
#include "ktagconfigdlg.h"
#include "configpatterns.h"

class KTagMainWin : public KMainWindow, virtual public DCOPiface
{
	Q_OBJECT

public:
	KTagMainWin( QWidget* parent = 0, const char* name = 0, WFlags fl = WType_TopLevel );
	~KTagMainWin();
	KTabWidget* tabWidget;
	
public slots:
	void openFile( const QString &fp );
	void config();
	void saveFile();
	void saveAll();
	bool chooseFile();

protected:
	void dragMoveEvent( QDragMoveEvent *);
	void closeEvent(QCloseEvent *);
	void setupActions();
	
protected slots:
	void dropEvent(QDropEvent *);
	void closeTab(QWidget*);
	void updateTabLabel(QWidget*, bool);

private:
	QPtrList<Ktag> ktagList;
	
};

#endif // KTAGMAINWIN_H
